namespace Commonmark.Internal {

    public class InlineParserContextImpl : GLib.Object, Parser.InlineParserContext {

        private Gee.List<Parser.Delimiter.DelimiterProcessor> delimiter_processors;
        private LinkReferenceDefinitions link_reference_definitions;

        public InlineParserContextImpl(
            Gee.List<Parser.Delimiter.DelimiterProcessor> delimiter_processors,
            LinkReferenceDefinitions link_reference_definitions) {
            this.delimiter_processors = delimiter_processors;
            this.link_reference_definitions = link_reference_definitions;
        }

        public Gee.List<Parser.Delimiter.DelimiterProcessor>
            get_custom_delimiter_processors() {
            return delimiter_processors;
        }

        public Node.LinkReferenceDefinition
            get_link_reference_definition(string label) {
            return link_reference_definitions.get_link(label);
        }
    }
}
