namespace Commonmark.Internal {

    public class LinkReferenceDefinitions : GLib.Object {

        /* LinkedHashMap for determinism and to preserve document order */
        private Gee.Map<string, Node.LinkReferenceDefinition> definitions;

        construct {
            // definitions = new Gee.HashMap<string,
            //     Node.LinkReferenceDefinition>();
            definitions = new Commonmark.Util.LinkedMap<string,
                Node.LinkReferenceDefinition>();
        }

        public void add(Node.LinkReferenceDefinition definition) {
            var l = definition.label;
            var normalized_label =
                Internal.Util.Escaping.normalize_label_content(l);

            /* spec: When there are multiple matching link reference
             * definitions, the first is used */
            if (!definitions.has_key(normalized_label)) {
                definitions[normalized_label] = definition;
            }
        }

        public Node.LinkReferenceDefinition get_link(string label) {
            var normalized_label =
                Internal.Util.Escaping.normalize_label_content(label);
            return definitions[normalized_label];
        }
    }
}
