namespace Commonmark.Internal.Renderer {

    public class NodeRendererMap : GLib.Object {

        private Gee.Map<GLib.Type, Commonmark.Renderer.NodeRenderer> renderers;

        construct {
            renderers = new Gee.HashMap<GLib.Type, Commonmark.Renderer.NodeRenderer>();
        }

        public void add(Commonmark.Renderer.NodeRenderer node_renderer) {
            foreach (var node_type in node_renderer.get_node_types()) {
                /* Overwrite existing renderer */
                renderers[node_type] = node_renderer;
            }
        }

        public void render(Node.Node node) {
            if (!renderers.has_key(node.get_type()))
                return;
            var node_renderer = renderers[node.get_type()];
            node_renderer.render(node);
        }
    }
}
