namespace Commonmark.Parser.Block {

    public abstract class AbstractBlockParser : GLib.Object, BlockParser {

        public virtual bool is_container() {
            return false;
        }

        public virtual bool can_have_lazy_continuation_lines() {
            return false;
        }

        public virtual bool can_contain(Node.Block child_block) {
            return false;
        }

        public virtual void add_line(SourceLine line) {}

        public virtual void add_source_span(Node.SourceSpan source_span) {
            get_block().add_source_span(source_span);
        }

        public virtual void close_block() {}

        public virtual void parse_inlines(InlineParser inline_parser) {}

        public abstract Node.Block get_block();

        public abstract BlockContinue try_continue(ParserState parser_state);
    }
}
