namespace Commonmark.Parser {

    /**
     * Whether to include Commonmark.Node.SourceSpan or not while parsing, see
     * Parser.Builder#include_source_spans(IncludeSourceSpans).
     */
    public enum IncludeSourceSpans {

        /**
         * Do not include source spans.
         */
        NONE,

        /**
         * Include source spans on {@link org.commonmark.node.Block} nodes.
         */
        BLOCKS,

        /**
         * Include source spans on block nodes and inline nodes.
         */
        BLOCKS_AND_INLINES;
    }
}
