using Commonmark.Internal;
using Commonmark.Internal.Util;

namespace Commonmark {

    // public static string spaces(int n) {
    //     var sb = new GLib.StringBuilder();
    //     for (int i = 0; i < n; i++)
    //         sb.append(" ");
    //     return sb.str;
    // }

    // public static void traverse(Node.Node node, int level=0) {
    //     if (node == null)
    //         return;
    //     var sp = spaces(level);
    //     stderr.printf("%sNode: %s\n", sp, node.to_string());
    //     var n = node.first_child;
    //     while (n != null) {
    //         traverse(n, level + 4);
    //         n = n.next;
    //     }
    // }

    public static int main(string[] args) {
        /* Forcing static construct. */
        if (new Html5Entities().get_type().name() == args[0] ||
            new Escaping().get_type().name() == args[0] ||
            new DocumentParser.from().get_type().name() == args[0])
            GLib.error("Error forcing static construct");

        try {
            var file = GLib.File.new_for_path("./data/test.md");
            var dis = new GLib.DataInputStream(file.read());
            var sb = new StringBuilder();
            string line;
            while ((line = dis.read_line(null)) != null) {
                sb.append(line);
                sb.append("\n");
            }
            var content = sb.str;
            var parser = Parser.Parser.builder().build();
            var document = parser.parse(content);
            // traverse(document);
            var renderer = Renderer.Html.HtmlRenderer.builder().build();
            var html = renderer.render(document);
            stdout.printf("%s", html);
        } catch (GLib.Error error) {
            GLib.error ("%s", error.message);
        }

        return 0;
    }
}
